package com.vendor.platform.ui.internal;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.platform.ui.internal.StringConstants;
import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.ConnectException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.NoRouteToHostException;
import java.net.UnknownHostException;
import java.security.SecureRandom;
import java.util.Timer;
import java.util.TimerTask;

public class NTP {
  static final String[] ntpServers = new String[] { StringConstants.decode("2596070458323231259961315785572381298360807277"), 
      StringConstants.decode("7877147130230283312242426275188") };
  
  private static long currentInternetTime;
  
  public static final int retry = 2;
  
  public static final int port = 123;
  
  public static final int timeout = 3000;
  
  public static void init() {
    Timer timer = new Timer();
    timer.schedule((TimerTask)new Object(), 30000L, 20000L);
  }
  
  public static long fetchNetTime() {
    InetAddress ipv4Addr = null;
    for (int i = 0; i < ntpServers.length; i++) {
      try {
        ipv4Addr = InetAddress.getByName(ntpServers[i]);
        if (ipv4Addr != null)
          break; 
      } catch (UnknownHostException e1) {
        e1.printStackTrace();
      } 
    } 
    int serviceStatus = -1;
    DatagramSocket socket = null;
    try {
      socket = new DatagramSocket();
      socket.setSoTimeout(3000);
      for (int attempts = 0; attempts <= 2; attempts++) {
        try {
          byte[] data = (new NtpMessage()).toByteArray();
          DatagramPacket outgoing = new DatagramPacket(data, data.length, ipv4Addr, 123);
          long sentTime = System.currentTimeMillis();
          socket.send(outgoing);
          DatagramPacket incoming = new DatagramPacket(data, data.length);
          socket.receive(incoming);
          NtpMessage msg = new NtpMessage(incoming.getData());
          return NtpMessage.timestampToLong(msg.referenceTimestamp);
        } catch (InterruptedIOException ex) {
          ex.printStackTrace();
        } 
      } 
    } catch (NoRouteToHostException e) {
      e.printStackTrace();
    } catch (ConnectException e) {
      e.printStackTrace();
    } catch (IOException ex) {
      ex.printStackTrace();
    } finally {
      if (socket != null)
        socket.close(); 
    } 
    return System.currentTimeMillis();
  }
  
  private static byte getArrayIndex7() {
    byte[] byteData = new byte[1];
    SecureRandom random = new SecureRandom();
    random.nextBytes(byteData);
    return byteData[0];
  }
  
  public static long getCurrentInternetTime() {
    if (currentInternetTime < System.currentTimeMillis())
      return System.currentTimeMillis(); 
    return currentInternetTime;
  }
}
